package com.gfg.kiit.baysafe.feature

import android.Manifest
import android.content.Context
import android.os.Build
import androidx.fragment.app.Fragment
import com.gfg.kiit.baysafe.data.DataDetails.PERMISSION_BACKGROUND_LOCATION_REQUEST_CODE
import com.gfg.kiit.baysafe.data.DataDetails.PERMISSION_INTERNET_REQUEST_CODE
import com.gfg.kiit.baysafe.data.DataDetails.PERMISSION_LOCATION_REQUEST_CODE
import com.vmadalin.easypermissions.EasyPermissions

object Permissions {

    fun hasLocationPermission(context: Context) =
        EasyPermissions.hasPermissions(
            context,
            Manifest.permission.ACCESS_FINE_LOCATION
        )

    fun requestsLocationPermission(fragment: Fragment) {
        EasyPermissions.requestPermissions(
            fragment,
            "This application cannot work without Location Permission.",
            PERMISSION_LOCATION_REQUEST_CODE,
            Manifest.permission.ACCESS_FINE_LOCATION
        )
    }
    fun hasInternetPermission(context: Context) =
        EasyPermissions.hasPermissions(
            context,
            Manifest.permission.INTERNET
        )
    fun requestsInternetPermission(fragment: Fragment) {
        EasyPermissions.requestPermissions(
            fragment,
            "This application cannot work without Internet Permission.",
            PERMISSION_INTERNET_REQUEST_CODE,
            Manifest.permission.INTERNET
        )
    }
    fun hasBackgroundLocationPermission(context: Context): Boolean {
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.Q) {
            return EasyPermissions.hasPermissions(
                context,
                Manifest.permission.ACCESS_BACKGROUND_LOCATION
            )
        }
        return true
    }

    fun requestsBackgroundLocationPermission(fragment: Fragment) {
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.Q) {
            EasyPermissions.requestPermissions(
                fragment,
                "Background location permission is essential to this application. Without it we will not be able to provide you with our service.",
                PERMISSION_BACKGROUND_LOCATION_REQUEST_CODE,
                Manifest.permission.ACCESS_BACKGROUND_LOCATION
            )
        }
    }

}